/**
 * This file is a part of Core - set of reusable tools and code.
 * All rights reserved.
 *
 * Developed by SourceModders.
 */

window.SourceModders = window.SourceModders || {};

(function ($, window, document, _undefined) {
    // По сути, это немного скопированный и доработанный XF.DescLoader
    window.SourceModders.DescLoader = XF.Element.newHandler({
        options: {
            descUrl: null,
            containerSelector: '.js-descTarget',
            changeTimer: 500
        },

        $container: null,
        changeTimer: null,
        xhr: null,

        init: function ()
        {
            if (!this.options.descUrl)
            {
                console.error('Element must have a data-desc-url value');
                return;
            }

            let $container = this.$target.parents('form').find(this.options.containerSelector);
            if (!$container.length)
            {
                console.error('Target element must have a ' + this.options.containerSelector + ' element');
                return;
            }

            this.$container = $container;
            this.$target.on('change', XF.proxy(this, 'change'));

            if ($container.html().length === 0)
            {
                this.change();
            }
        },

        change: function ()
        {
            if (this.changeTimer)
            {
                clearTimeout(this.changeTimer);
            }

            if (this.xhr)
            {
                this.xhr.abort();
                this.xhr = null;
            }

            this.changeTimer = setTimeout(XF.proxy(this, 'onTimer'), this.options.changeTimer);
        },

        onTimer: function()
        {
            let value = this.$target.val();
            if (!value)
            {
                this.$container.xfFadeUp(XF.config.speed.fast);
                return;
            }

            this.xhr = XF.ajax('post', this.options.descUrl, { id: value }, XF.proxy(this, 'onLoad'));
        },

        onLoad: function(data)
        {
            let $container = this.$container;
            if (data.description)
            {
                XF.setupHtmlInsert(data.description, function($html, container, onComplete)
                {
                    $container.xfFadeUp(XF.config.speed.fast, function()
                    {
                        $container.html($html);
                        $container.xfFadeDown(XF.config.speed.normal);
                    });
                });
            }
            else
            {
                $container.xfFadeUp(XF.config.speed.fast);
            }

            this.xhr = null;
        }
    });

    XF.Element.register('smcore-desc-loader', 'SourceModders.DescLoader');
})(jQuery, window, document);
