<?php

/**
 * This file is a part of Core - set of reusable tools and code.
 * All rights reserved.
 *
 * Developed by SourceModders.
 */

namespace SModders\Core\Data;


use XF\Db\AbstractAdapter;

class DbDriver
{
    /**
     * @param AbstractAdapter $adapter
     * @return mixed|string
     */
    public function resolveAdapterName(AbstractAdapter $adapter)
    {
        $className = get_class($adapter);
        $adapters = self::getAdapterMap();
        
        if (!array_key_exists($className, $adapters))
        {
            return '';
        }

        return $adapters[$className];
    }
    
    /**
     * @return array
     */
    public function getAdapterMap()
    {
        return [
            'XF\Db\Mysqli\Adapter'              => 'MySql',
            'XF\Db\Mysqli\ReplicationAdapter'   => 'MySql',
            
            'XF\Db\PostgreSql\Adapter'          => 'PostgreSql'
        ];
    }
}